﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Arction.WinForms.Charting;
using Arction.WinForms.Charting.Annotations;
using Arction.WinForms.Charting.Axes;
using Arction.WinForms.Charting.SeriesXY;
using Arction.WinForms.Charting.Views.ViewXY;

namespace LightningChart_issue
{
    public partial class Form1 : Form
    {
        private Arction.WinForms.Charting.LightningChart chart;

        public Form1()
        {
            InitializeComponent();
            InitChart();
        }

        private void InitChart()
        {
            Arction.WinForms.Charting.LightningChart.SetDeploymentKey("???");

            chart = new LightningChart();

            chart.BeginUpdate();

            try
            {
                chart.Name = "Chart";
                chart.Title.Visible = false;
                chart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) | System.Windows.Forms.AnchorStyles.Left) | System.Windows.Forms.AnchorStyles.Right)));

                chart.Parent = this;

                chart.ViewXY.LegendBoxes[0].Visible = false;
                chart.Dock = DockStyle.Fill;

                CreateAnnotation();

                chart.ShowPropertiesEditor();
            }
            finally
            {
                chart.EndUpdate();
            }

        }

        private void CreateAnnotation()
        {
            AnnotationXY annotation = new AnnotationXY(chart.ViewXY,
                                                          chart.ViewXY.XAxes[0],
                                                          chart.ViewXY.YAxes[0]);
            annotation.Style = AnnotationStyle.Rectangle;
            annotation.LocationCoordinateSystem = CoordinateSystem.ScreenCoordinates;
            annotation.Sizing = AnnotationXYSizing.ScreenCoordinates;
            annotation.TextStyle.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            annotation.TextStyle.HorizAlign = AlignmentHorizontal.Left;
            annotation.TextStyle.Color = Color.White;

            annotation.Highlight = Highlight.None;
            annotation.Shadow.Visible = false;
            annotation.BorderVisible = false;
            annotation.AllowTargetMove = false;
            annotation.AllowDragging = false;
            annotation.AllowResize = false;
            annotation.AllowRotate = false;
            annotation.AllowUserInteraction = false;

            annotation.Text = "TEST";

            SizeF textsize = chart.CreateGraphics().MeasureString(annotation.Text, annotation.TextStyle.Font);

            annotation.SizeScreenCoords.SetValues(1, textsize.Height + 2);
            annotation.Visible = true;
            annotation.KeepVisible = true;
            chart.ViewXY.Annotations.Add(annotation);
        }
    }
}
